//    -      14 .  
//1-  -  2009 
//  -  2011 
//ATmega48 - Program: 2538 bytes (62.0 % Full), Data: 58 bytes (11.3 % Full), EEPROM: 3 bytes (1.2 % Full) 
//:  .. www.embed.com.ua 

//  

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h> 

//    
#define NUMBER PORTD     /* A -   */
#define DIG1 PD7         /* 1-  */ 
#define DIG2 PB0         /* 2-  */
#define DIG3 PB1         /* 3-  */ 
#define DIG4 PC5         /* 4-  */
#define BUZZ  PC0        /* */
#define PORT_DIG1 PORTD  /* 1 */
#define PORT_DIG2 PORTB  /* 2 */
#define PORT_DIG3 PORTB  /* 3 */
#define PORT_DIG4 PORTC  /* 4 */
#define vref 3291        /*  -   (     )*/
#define Vmax 250         /* */
#define Vmin 200         /* */
#define button PC1       /* */

#define PI_PIP TCCR2B |= _BV(CS21) /*  - (  2)*/

const unsigned char cifra [] = {0x3F,0x30,0x57,0x75,0x78,0x6D,0x6F,0x31,0x7F,0x7D};//     
const unsigned char phase [] = {0x01,0x40,0x04};//  -   
unsigned char phase_pointer,count2;//      200    
unsigned long V [3];//     
unsigned char sot[3];//  .....................
unsigned char des[3];// ...................
unsigned char edi[3];// ....................
float coeff [] = {11.9,11.9,11.9};//    
EEMEM unsigned char coeff_e [3] = {100,100,100};//     

void eeprom_wb (unsigned int addr, unsigned char value)//    
{
    while(EECR & (1<<EEWE));//   
	EEAR = addr;//   
	EEDR = value;//   
	EECR |= (1<<EEMWE);//  EEMWE
	EECR |= (1<<EEWE);// 
}

unsigned char eeprom_rb (unsigned int addr)//    
{
    while(EECR & (1<<EEWE));
	EEAR = addr;
	EECR |= (1<<EERE);
	return EEDR;
}

void podsvet (void) //   
{
    static unsigned char q;//   
	
	q++;// 
	switch(q) //   
		{
    	    case 1:PORT_DIG4 &= ~_BV(DIG4);//  
			       PORTD &= 0x80; PORTD |= cifra[edi[phase_pointer]];//  
	               PORT_DIG1 |= _BV(DIG1);//  
			break;
			
			case 2:PORT_DIG1 &= ~_BV(DIG1);
			       PORTD &= 0x80; PORTD |= cifra[des[phase_pointer]];
	               PORT_DIG2 |= _BV(DIG2);
		    break;
			
			case 3:PORT_DIG2 &= ~_BV(DIG2);
			       PORTD &= 0x80; PORTD |= cifra[sot[phase_pointer]];
	               PORT_DIG3 |= _BV(DIG3);
			break;
			
			case 4:PORT_DIG3 &= ~_BV(DIG3);
			       PORTD &= 0x80; PORTD |= phase[phase_pointer];
	               PORT_DIG4 |= _BV(DIG4);
				   q=0;//   4-   
			break;
			
		    default:
		    break;
		}
}

void A_D_C (void)//   
{
    static unsigned char chanel;//  
    static unsigned long  Umax;// 
	static unsigned int i;//   
	unsigned int U;//  
	
	ADCSRA |=(1<<ADSC);// 
    while(!(ADCSRA & (1<<ADIF)));//  
    ADCSRA |=(1<<ADIF);//   1
	U = ADCW;//   
    if(U > Umax) Umax=U;//   ,      (  )
	if(i++ >= 1000) //   1000
	{	
        V[chanel]= (Umax*vref/1023)/coeff[chanel];//     
	    sot[chanel] = (V[chanel]%1000)/100;// 
	    des[chanel] = ((V[chanel]%1000)%100)/10;//....
	    edi[chanel] = ((V[chanel]%1000)%100)%10;//....
		if(chanel++ >=2) chanel=0;//    ,,     -   
		ADMUX = 0b01000000;//
        ADMUX |= chanel+2;//  
		Umax=i=0;//      
	}	
}

ISR (TIMER0_COMPA_vect)//    0  1 
{
    if(count2) count2--;//     
}

ISR (TIMER2_OVF_vect) // 2 -  
{
   static unsigned char w;//,   "-"
	
	if(w++ < 100) PORTC ^= _BV(BUZZ);//    -      ()
	else //  
	{
	    w=0;//  
		TCCR2B = 0;// 
	}
}

int main (void)// 
{
    unsigned int p, e_inc, e_dec, n;// 
	
	DDRB |= (1<<DIG2) | (1<<DIG3) ;//  2  3
	DDRB &= ~(1<<PB3);// 
	DDRB &= ~(1<<PB4);//    
	DDRB &= ~(1<<PB5);//    EEPROM
	PORTB |= (1<<PB3) | (1<<PB4) | (1<<PB5);// 
	DDRC |= (1<<DIG4) | (1<<BUZZ);//  4  
	DDRC &= ~(1<<button);//   
	PORTC |= (1<<button);// 
	DDRD = 0xFF;//     1
	
	ADMUX |= (1<<REFS0);//  -        Uref
	ADCSRA |= (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);//  ,   
	DIDR0 |= (1<<ADC4D) | (1<<ADC3D) | (1<<ADC2D);//    
		
	TCCR0A |= (1<<WGM01);// 0   
	OCR0A = 125;// 1 
	TIMSK0 = (1<<OCIE0A);// 
	count2=200;// 200 
	TCCR0B |= (1<<CS01) | (1<<CS00);//  
	
	TIMSK2 |= _BV(TOIE2);//     2
	
	for(p=0;p<3;p++)//    
	{
	    n = eeprom_rb(&coeff_e[p]);//     (  ,   100)
		
	    if(n > 100)//    100 ( )
        {
            n = n - 100;//    
			coeff[p] += n*0.05;//       
		}
		
		else if(n < 100)//    100 ( )
        {
            n = 100 - n;//    
            coeff[p] -= n*0.05;//       
        }
    }	
		
	sei();//  
	
	while (1)// 
	{
	    if(count2==0)//  200 
		{
	        if(bit_is_clear(PINC, button))//    
		    {		    
			    if(phase_pointer++ >=2) phase_pointer=0;//    (   )
				PI_PIP;//  
			}
			
			if(bit_is_clear(PINB, PB3))//      
		    {		    
			    coeff[phase_pointer] += 0.05;//  
				cli();//       
				e_inc = eeprom_rb(&coeff_e[phase_pointer]);//   (  100)  
				e_inc++;//   1
				eeprom_wb(&coeff_e[phase_pointer],e_inc);//  
				sei();// 
				PI_PIP;// 
			}
			
			if(bit_is_clear(PINB, PB4))//      
		    {		    
			    coeff[phase_pointer] -= 0.05;//  
				cli();
				e_dec = eeprom_rb(&coeff_e[phase_pointer]);//      (. )  
				e_dec--;
				eeprom_wb(&coeff_e[phase_pointer],e_dec);
				sei();
				PI_PIP;
			}
			
			count2=200;//  200 
		}
		
	   A_D_C();//  
       podsvet();//
	   
	   for(p=0;p<3;p++)//  
	    {
	        if((V[p] > Vmax) || (V[p] < Vmin))//        
			{
                TCCR2B |= _BV(CS21)  | _BV(CS20);//  -   -
			}
		}
    }	    
}

